from typing import Optional, Self

from edge.com import fs
from edge.landmark.types import LandmarkServiceArgs


class JsonLandmarkServiceArgs(LandmarkServiceArgs):
    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)

    @classmethod
    def deserialize(cls, camera_conf_jnode_path: str, location_jnode_path: str) -> Optional[Self]:
        """
        :raises JnodeError:
        """
        camera_conf_jnode = fs.load_json3(camera_conf_jnode_path, default=None)

        intrinsic_jnode = camera_conf_jnode.get('ro', {}).get('intrinsic')\
            or camera_conf_jnode.get('rw', {}).get('conf', {}).get('intrinsic')\
            or dict()

        if not intrinsic_jnode.get('active', True):
            return None

        return cls(camera_conf_jnode_path, location_jnode_path)
