from typing import Dict, List, Self

from edge_bbox.types import QuadI


class ITrack:
    def __init__(self, trace):
        pass

    @property
    def trace(self) -> List[int]:
        raise NotImplementedError

    @property
    def direction(self) -> int:
        raise NotImplementedError


class LrTrackItem:
    def __init__(self, ts: int, plate_weight: int, plate_quad: QuadI):
        self.ts = ts
        self.plate_weight = plate_weight
        self.plate_quad = plate_quad

    @classmethod
    def deserialize(cls, jnode: Dict) -> Self:
        """
        :param jnode: TrTrack#/Lr/PlateTrace/:index
        """
        ts = jnode['Ts']
        weight = jnode['W']
        quad = QuadI.unpack(jnode['Q'])

        return cls(ts, weight, quad)
