from typing import Callable, List


class AppError(RuntimeError):
    def __init__(self, log_entry: str):
        self._log = [log_entry]

    def extend(self, log_entry: str) -> None:
        self._log.append(log_entry)

    def foreach(self, fn: Callable[[str], None]) -> None:
        for entry in self._log[::-1]:  # reverse
            fn(entry)

    @property
    def log(self) -> List[str]:
        return self._log
